Backend API
$(() => {
const aiService = new AzureOpenAI({
dangerouslyAllowBrowser: true,
deployment,
endpoint,
apiVersion,
apiKey,
});
async function getAIResponse(messages, signal) {
const params = {
messages,
model: deployment,
max_completion_tokens: 1000,
temperature: 0.7,
};
const response = await aiService.chat.completions.create(params, { signal });
const result = response.choices[0].message?.content;
return result;
}
const aiIntegration = new DevExpress.aiIntegration.AIIntegration({
sendRequest({ prompt }) {
const controller = new AbortController();
const signal = controller.signal;
const aiPrompt = [
{ role: 'system', content: prompt.system },
{ role: 'user', content: prompt.user },
];
const promise = getAIResponse(aiPrompt, signal);
promise.catch(() => {
showNotification('Something went wrong. Please try again.', '#form', true);
});
const result = {
promise,
abort: () => {
controller.abort();
},
};
return result;
},
});
const showNotification = (message, of, isError, offset) => {
DevExpress.ui.notify({
message,
position: {
my: 'bottom center',
at: 'bottom center',
of,
offset: offset ?? '0 -50',
},
width: 'fit-content',
maxWidth: 'fit-content',
minWidth: 'fit-content',
}, isError ? 'error' : 'info', 1500);
};
const customSmartPasteHandler = () => {
navigator.clipboard.readText()
.then((text) => {
if (text) {
form.smartPaste(text);
} else {
showNotification(
'Clipboard is empty. Copy text before pasting',
'#form',
);
}
})
.catch(() => {
showNotification(
'Could not access the clipboard',
'#form',
);
});
};
const colCountByScreen = {
xs: 2,
sm: 2,
md: 2,
lg: 2,
};
const stylingMode = 'filled';
const form = $('#form').dxForm({
formData: {},
aiIntegration,
labelMode: 'outside',
showColonAfterLabel: false,
labelLocation: 'top',
minColWidth: 220,
items: [{
itemType: 'group',
caption: 'Billing Summary',
colCountByScreen,
items: [{
dataField: 'Amount Due',
editorType: 'dxTextBox',
editorOptions: {
placeholder: '$0.00',
stylingMode,
},
aiOptions: {
instruction: 'Format as the following: $0.00',
},
}, {
dataField: 'Statement Date',
editorType: 'dxDateBox',
editorOptions: {
placeholder: 'MM/DD/YYYY',
stylingMode: 'filled',
},
aiOptions: {
instruction: 'Format as the following: MM/DD/YYYY',
},
}],
}, {
itemType: 'group',
caption: 'Billing Information',
colCountByScreen,
items: [{
dataField: 'First Name',
editorType: 'dxTextBox',
editorOptions: {
stylingMode,
},
}, {
dataField: 'Last Name',
editorType: 'dxTextBox',
editorOptions: {
stylingMode,
},
}, {
dataField: 'Phone Number',
editorType: 'dxTextBox',
editorOptions: {
placeholder: '(000) 000-0000',
stylingMode,
},
aiOptions: {
instruction: 'Format as the following: (000) 000-0000',
},
}, {
dataField: 'Email',
editorType: 'dxTextBox',
editorOptions: {
stylingMode,
},
validationRules: [{ type: 'email' }],
aiOptions: {
instruction: 'Do not fill this field if the text contains an invalid email address. A valid email is in the following format: email@example.com',
},
}],
}, {
itemType: 'group',
caption: 'Billing Address',
colCountByScreen,
items: [{
dataField: 'Street Address',
editorType: 'dxTextBox',
editorOptions: {
stylingMode,
},
}, {
dataField: 'City',
editorType: 'dxTextBox',
editorOptions: {
stylingMode,
},
}, {
dataField: 'State/Province/Region',
editorType: 'dxTextBox',
editorOptions: {
stylingMode,
},
}, {
dataField: 'ZIP',
editorType: 'dxNumberBox',
editorOptions: {
stylingMode,
mode: 'text',
},
aiOptions: {
instruction: 'If the text does not contain a ZIP, determine the ZIP code from the provided address.',
},
}],
}, {
itemType: 'group',
cssClass: 'buttons-group',
colCountByScreen,
items: [{
itemType: 'button',
name: 'smartPaste',
buttonOptions: {
stylingMode: 'contained',
type: 'default',
},
}, {
itemType: 'button',
name: 'reset',
buttonOptions: {
stylingMode: 'outlined',
type: 'normal',
},
}],
}],
}).dxForm('instance');
const textArea = $('#textarea').dxTextArea({
value: defaultText,
stylingMode,
inputAttr: { 'aria-labelledby': 'textarea-label' },
height: '100%',
}).dxTextArea('instance');
$('#copy').dxButton({
text: 'Copy Text',
icon: 'copy',
stylingMode: 'contained',
type: 'default',
width: 'fit-content',
onClick: () => {
const { value } = textArea.option();
navigator.clipboard.writeText(value);
showNotification(
'Text copied to clipboard',
'#textarea',
false,
'0 -20',
);
},
});
form.registerKeyHandler('V', (event) => {
if (event.ctrlKey && event.shiftKey) {
customSmartPasteHandler();
}
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<script type="module">
import { AzureOpenAI } from "https://esm.sh/openai@4.73.1";
window.AzureOpenAI = AzureOpenAI;
</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="js/dx.all.debug.js"></script>
<script src="js/dx.ai-integration.js"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div class="instruction" id="textarea-label">Copy text from the editor below to the clipboard. Edit the text to see how your changes affect Smart Paste result.</div>
<div class="instruction">Paste text from the clipboard to populate the form. Press Ctrl+Shift+V (when the form is focused) or use the "Smart Paste" button under the form.</div>
<div class="textarea-container">
<div id="copy"></div>
<div id="textarea"></div>
</div>
<div id="form"></div>
</div>
</body>
</html>
.demo-container {
display: grid;
grid-template-columns: 1fr 2fr;
grid-template-rows: auto auto;
gap: 24px 40px;
min-width: 720px;
max-width: 900px;
margin: auto;
}
.instruction {
color: var(--dx-texteditor-color-label);
}
.textarea-container {
display: flex;
flex-direction: column;
gap: 16px;
}
.dx-layout-manager .dx-field-item.dx-last-row {
padding-top: 4px;
}
.dx-toast-info .dx-toast-icon {
display: none;
}
.buttons-group {
display: flex;
width: 100%;
justify-content: end;
}
.buttons-group .dx-item-content {
gap: 8px;
}
.buttons-group .dx-field-item:not(.dx-first-col),
.buttons-group .dx-field-item:not(.dx-last-col) {
padding: 0;
}
.buttons-group .dx-item {
flex: unset !important;
}
const deployment = 'demo-mini';
const apiVersion = '2024-02-01';
const endpoint = 'https://public-api.devexpress.com/demo-openai';
const apiKey = 'DEMO';
const defaultText = `Payment: Amount - $123.00
Statement Date: 10/15/2024
Name: John Smith
Contact: (123) 456-7890
Email: john@myemail.com
Address:
- 123 Elm St Apt 4B
- New York, NY 10001
`;
Use the following APIs to activate Smart Paste in our JavaScript Form component:
- aiIntegration - accepts an AIIntegration object that contains AI Service settings.
- 'smartPaste' – adds a built-in Smart Paste button to the JavaScript Form (see name for additional information). To use this capability in code, call the smartPaste(text) method. This sample leverages this method and implements a custom shortcut to activate Smart Paste.
Configure each JavaScript Form item using aiOptions:
- disabled - prevents AI-generated text from being pasted into this item.
- instruction - specifies item instruction for the AI service.

Backend API
import React, { useCallback, useEffect, useRef, useState } from 'react';
import { AzureOpenAI, type OpenAI } from 'openai';
import { AIIntegration } from 'devextreme-react/common/ai-integration';
import type { AIResponse, RequestParams, Response } from 'devextreme-react/common/ai-integration';
import type { ValidationRule } from 'devextreme-react/common';
import { Button } from 'devextreme-react/button';
import type { ButtonTypes } from 'devextreme-react/button';
import {
Form,
Item,
GroupItem,
ButtonItem,
} from 'devextreme-react/form';
import type { FormRef } from 'devextreme-react/form';
import { TextArea } from 'devextreme-react/text-area';
import type { TextAreaTypes } from 'devextreme-react/text-area';
import notify from 'devextreme/ui/notify';
import type { ITextBoxOptions } from 'devextreme-react/text-box';
import type { IDateBoxOptions } from 'devextreme-react/date-box';
import type { INumberBoxOptions } from 'devextreme-react/number-box';
import { AzureOpenAIConfig, defaultText } from './data.ts';
type AIMessage = (OpenAI.ChatCompletionUserMessageParam | OpenAI.ChatCompletionSystemMessageParam) & {
content: string;
};
const stylingMode = 'filled';
const amountDueEditorOptions: ITextBoxOptions = { placeholder: '$0.00', stylingMode };
const amountDueAIOptions = { instruction: 'Format as the following: $0.00' };
const statementDueEditorOptions: IDateBoxOptions = { placeholder: 'MM/DD/YYYY', stylingMode };
const statementDueAIOptions = { instruction: 'Format as the following: MM/DD/YYYY' };
const textEditorOptions: ITextBoxOptions = { stylingMode };
const phoneEditorOptions: ITextBoxOptions = { placeholder: '(000) 000-0000', stylingMode };
const phoneAIOptions = { instruction: 'Format as the following: (000) 000-0000' };
const emailValidationRules: ValidationRule[] = [{ type: 'email' }];
const emailAIOptions = { instruction: 'Do not fill this field if the text contains an invalid email address. A valid email is in the following format: email@example.com' };
const zipEditorOptions: INumberBoxOptions = { stylingMode, mode: 'text' };
const zipAIOptions = { instruction: 'If the text does not contain a ZIP, determine the ZIP code from the provided address.' };
const resetButtonOptions: ButtonTypes.Properties = {
stylingMode: 'outlined',
type: 'normal',
};
const smartPasteButtonOptions: ButtonTypes.Properties = {
stylingMode: 'contained',
type: 'default',
};
const colCountByScreen = {
xs: 2,
sm: 2,
md: 2,
lg: 2,
};
const showNotification = (message: string, of: string, isError?: boolean, offset?: string): void => {
notify({
message,
position: {
my: 'bottom center',
at: 'bottom center',
of,
offset: offset ?? '0 -50',
},
width: 'fit-content',
maxWidth: 'fit-content',
minWidth: 'fit-content',
}, isError ? 'error' : 'info', 1500);
};
const aiService = new AzureOpenAI(AzureOpenAIConfig);
export async function getAIResponse(messages: AIMessage[], signal: AbortSignal): Promise<AIResponse> {
const params = {
messages,
model: AzureOpenAIConfig.deployment,
max_completion_tokens: 1000,
temperature: 0.7,
};
const response = await aiService.chat.completions.create(params, { signal });
return response.choices[0].message?.content ?? '';
}
export const aiIntegration = new AIIntegration({
sendRequest({ prompt }: RequestParams): Response {
const controller = new AbortController();
const signal = controller.signal;
const aiPrompt: AIMessage[] = [
{ role: 'system', content: prompt.system ?? '' },
{ role: 'user', content: prompt.user ?? '' },
];
const promise = getAIResponse(aiPrompt, signal);
promise.catch((): void => {
showNotification('Something went wrong. Please try again.', '#form', true);
});
return {
promise,
abort: (): void => {
controller.abort();
},
};
},
});
const App = () => {
const formRef = useRef<FormRef>(null);
const [text, setText] = useState<string>(defaultText);
const onCopy = useCallback(() => {
navigator.clipboard.writeText(text);
showNotification('Text copied to clipboard', '#textarea', false, '0 -20');
}, [text]);
const shortcutHandler = useCallback((event: KeyboardEvent): void => {
if (event.ctrlKey && event.shiftKey) {
navigator.clipboard.readText()
.then((clipboardText: string): void => {
if (clipboardText) {
formRef.current?.instance().smartPaste(clipboardText);
} else {
showNotification('Clipboard is empty. Copy text before pasting', '#form');
}
})
.catch((): void => {
showNotification('Could not access the clipboard', '#form');
});
}
}, []);
useEffect(() => {
formRef.current?.instance().registerKeyHandler('V', shortcutHandler);
}, [shortcutHandler]);
const onTextAreaValueChanged = useCallback((e: TextAreaTypes.ValueChangedEvent): void => {
setText(e.value);
}, []);
return (
<>
<div id="textarea-label" className="instruction">
Copy text from the editor below to the clipboard. Edit the text to see how your changes affect Smart Paste result.
</div>
<div className="instruction">
Paste text from the clipboard to populate the form. Press Ctrl+Shift+V (when the form is focused) or use the "Smart Paste" button under the form.
</div>
<div className="textarea-container">
<Button
text="Copy Text"
icon="copy"
stylingMode="contained"
type="default"
width="fit-content"
onClick={onCopy}
/>
<TextArea
id="textarea"
inputAttr={{ 'aria-labelledby': 'textarea-label' }}
value={text}
stylingMode="filled"
height="100%"
onValueChanged={onTextAreaValueChanged}
/>
</div>
<Form
id="form"
ref={formRef}
labelMode="outside"
labelLocation="top"
showColonAfterLabel={false}
minColWidth={220}
aiIntegration={aiIntegration}
>
<GroupItem colCountByScreen={colCountByScreen} caption="Billing Summary">
<Item
dataField="Amount Due"
editorType="dxTextBox"
editorOptions={amountDueEditorOptions}
aiOptions={amountDueAIOptions}
/>
<Item
dataField="Statement Date"
editorType="dxDateBox"
editorOptions={statementDueEditorOptions}
aiOptions={statementDueAIOptions}
/>
</GroupItem>
<GroupItem colCountByScreen={colCountByScreen} caption="Billing Information">
<Item
dataField="First Name"
editorType="dxTextBox"
editorOptions={textEditorOptions}
/>
<Item
dataField="Last Name"
editorType="dxTextBox"
editorOptions={textEditorOptions}
/>
<Item
dataField="Phone Number"
editorType="dxTextBox"
editorOptions={phoneEditorOptions}
aiOptions={phoneAIOptions}
/>
<Item
dataField="Email"
editorType="dxTextBox"
editorOptions={textEditorOptions}
aiOptions={emailAIOptions}
validationRules={emailValidationRules}
/>
</GroupItem>
<GroupItem colCountByScreen={colCountByScreen} caption="Billing Address">
<Item
dataField="Street Address"
editorType="dxTextBox"
editorOptions={textEditorOptions}
/>
<Item
dataField="City"
editorType="dxTextBox"
editorOptions={textEditorOptions}
/>
<Item
dataField="State/Province/Region"
editorType="dxTextBox"
editorOptions={textEditorOptions}
/>
<Item
dataField="ZIP"
editorType="dxNumberBox"
editorOptions={zipEditorOptions}
aiOptions={zipAIOptions}
/>
</GroupItem>
<GroupItem cssClass="buttons-group" colCountByScreen={colCountByScreen}>
<ButtonItem buttonOptions={smartPasteButtonOptions} name="smartPaste" />
<ButtonItem buttonOptions={resetButtonOptions} name="reset" />
</GroupItem>
</Form>
</>
);
};
export default App;
import React, {
useCallback, useEffect, useRef, useState,
} from 'react';
import { AzureOpenAI } from 'openai';
import { AIIntegration } from 'devextreme-react/common/ai-integration';
import { Button } from 'devextreme-react/button';
import {
Form, Item, GroupItem, ButtonItem,
} from 'devextreme-react/form';
import { TextArea } from 'devextreme-react/text-area';
import notify from 'devextreme/ui/notify';
import { AzureOpenAIConfig, defaultText } from './data.js';
const stylingMode = 'filled';
const amountDueEditorOptions = { placeholder: '$0.00', stylingMode };
const amountDueAIOptions = { instruction: 'Format as the following: $0.00' };
const statementDueEditorOptions = { placeholder: 'MM/DD/YYYY', stylingMode };
const statementDueAIOptions = { instruction: 'Format as the following: MM/DD/YYYY' };
const textEditorOptions = { stylingMode };
const phoneEditorOptions = { placeholder: '(000) 000-0000', stylingMode };
const phoneAIOptions = { instruction: 'Format as the following: (000) 000-0000' };
const emailValidationRules = [{ type: 'email' }];
const emailAIOptions = {
instruction:
'Do not fill this field if the text contains an invalid email address. A valid email is in the following format: email@example.com',
};
const zipEditorOptions = { stylingMode, mode: 'text' };
const zipAIOptions = {
instruction:
'If the text does not contain a ZIP, determine the ZIP code from the provided address.',
};
const resetButtonOptions = {
stylingMode: 'outlined',
type: 'normal',
};
const smartPasteButtonOptions = {
stylingMode: 'contained',
type: 'default',
};
const colCountByScreen = {
xs: 2,
sm: 2,
md: 2,
lg: 2,
};
const showNotification = (message, of, isError, offset) => {
notify(
{
message,
position: {
my: 'bottom center',
at: 'bottom center',
of,
offset: offset ?? '0 -50',
},
width: 'fit-content',
maxWidth: 'fit-content',
minWidth: 'fit-content',
},
isError ? 'error' : 'info',
1500,
);
};
const aiService = new AzureOpenAI(AzureOpenAIConfig);
export async function getAIResponse(messages, signal) {
const params = {
messages,
model: AzureOpenAIConfig.deployment,
max_completion_tokens: 1000,
temperature: 0.7,
};
const response = await aiService.chat.completions.create(params, { signal });
return response.choices[0].message?.content ?? '';
}
export const aiIntegration = new AIIntegration({
sendRequest({ prompt }) {
const controller = new AbortController();
const signal = controller.signal;
const aiPrompt = [
{ role: 'system', content: prompt.system ?? '' },
{ role: 'user', content: prompt.user ?? '' },
];
const promise = getAIResponse(aiPrompt, signal);
promise.catch(() => {
showNotification('Something went wrong. Please try again.', '#form', true);
});
return {
promise,
abort: () => {
controller.abort();
},
};
},
});
const App = () => {
const formRef = useRef(null);
const [text, setText] = useState(defaultText);
const onCopy = useCallback(() => {
navigator.clipboard.writeText(text);
showNotification('Text copied to clipboard', '#textarea', false, '0 -20');
}, [text]);
const shortcutHandler = useCallback((event) => {
if (event.ctrlKey && event.shiftKey) {
navigator.clipboard
.readText()
.then((clipboardText) => {
if (clipboardText) {
formRef.current?.instance().smartPaste(clipboardText);
} else {
showNotification('Clipboard is empty. Copy text before pasting', '#form');
}
})
.catch(() => {
showNotification('Could not access the clipboard', '#form');
});
}
}, []);
useEffect(() => {
formRef.current?.instance().registerKeyHandler('V', shortcutHandler);
}, [shortcutHandler]);
const onTextAreaValueChanged = useCallback((e) => {
setText(e.value);
}, []);
return (
<>
<div
id="textarea-label"
className="instruction"
>
Copy text from the editor below to the clipboard. Edit the text to see how your changes
affect Smart Paste result.
</div>
<div className="instruction">
Paste text from the clipboard to populate the form. Press Ctrl+Shift+V (when the form is
focused) or use the "Smart Paste" button under the form.
</div>
<div className="textarea-container">
<Button
text="Copy Text"
icon="copy"
stylingMode="contained"
type="default"
width="fit-content"
onClick={onCopy}
/>
<TextArea
id="textarea"
inputAttr={{ 'aria-labelledby': 'textarea-label' }}
value={text}
stylingMode="filled"
height="100%"
onValueChanged={onTextAreaValueChanged}
/>
</div>
<Form
id="form"
ref={formRef}
labelMode="outside"
labelLocation="top"
showColonAfterLabel={false}
minColWidth={220}
aiIntegration={aiIntegration}
>
<GroupItem
colCountByScreen={colCountByScreen}
caption="Billing Summary"
>
<Item
dataField="Amount Due"
editorType="dxTextBox"
editorOptions={amountDueEditorOptions}
aiOptions={amountDueAIOptions}
/>
<Item
dataField="Statement Date"
editorType="dxDateBox"
editorOptions={statementDueEditorOptions}
aiOptions={statementDueAIOptions}
/>
</GroupItem>
<GroupItem
colCountByScreen={colCountByScreen}
caption="Billing Information"
>
<Item
dataField="First Name"
editorType="dxTextBox"
editorOptions={textEditorOptions}
/>
<Item
dataField="Last Name"
editorType="dxTextBox"
editorOptions={textEditorOptions}
/>
<Item
dataField="Phone Number"
editorType="dxTextBox"
editorOptions={phoneEditorOptions}
aiOptions={phoneAIOptions}
/>
<Item
dataField="Email"
editorType="dxTextBox"
editorOptions={textEditorOptions}
aiOptions={emailAIOptions}
validationRules={emailValidationRules}
/>
</GroupItem>
<GroupItem
colCountByScreen={colCountByScreen}
caption="Billing Address"
>
<Item
dataField="Street Address"
editorType="dxTextBox"
editorOptions={textEditorOptions}
/>
<Item
dataField="City"
editorType="dxTextBox"
editorOptions={textEditorOptions}
/>
<Item
dataField="State/Province/Region"
editorType="dxTextBox"
editorOptions={textEditorOptions}
/>
<Item
dataField="ZIP"
editorType="dxNumberBox"
editorOptions={zipEditorOptions}
aiOptions={zipAIOptions}
/>
</GroupItem>
<GroupItem
cssClass="buttons-group"
colCountByScreen={colCountByScreen}
>
<ButtonItem
buttonOptions={smartPasteButtonOptions}
name="smartPaste"
/>
<ButtonItem
buttonOptions={resetButtonOptions}
name="reset"
/>
</GroupItem>
</Form>
</>
);
};
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
export const AzureOpenAIConfig = {
dangerouslyAllowBrowser: true,
deployment: 'demo-mini',
apiVersion: '2024-02-01',
endpoint: 'https://public-api.devexpress.com/demo-openai',
apiKey: 'DEMO',
};
export const defaultText = `Payment: Amount - $123.00
Statement Date: 10/15/2024
Name: John Smith
Contact: (123) 456-7890
Email: john@myemail.com
Address:
- 123 Elm St Apt 4B
- New York, NY 10001
`;
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'openai': 'externals:openai.bundle.js',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"openai": {
"version": "4.73.1"
},
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const AzureOpenAIConfig = {
dangerouslyAllowBrowser: true,
deployment: 'demo-mini',
apiVersion: '2024-02-01',
endpoint: 'https://public-api.devexpress.com/demo-openai',
apiKey: 'DEMO',
};
export const defaultText = `Payment: Amount - $123.00
Statement Date: 10/15/2024
Name: John Smith
Contact: (123) 456-7890
Email: john@myemail.com
Address:
- 123 Elm St Apt 4B
- New York, NY 10001
`;
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#app {
display: grid;
grid-template-columns: 1fr 2fr;
grid-template-rows: auto auto;
gap: 24px 40px;
min-width: 720px;
max-width: 900px;
margin: auto;
}
.instruction {
color: var(--dx-texteditor-color-label);
}
.textarea-container {
display: flex;
flex-direction: column;
gap: 16px;
}
.dx-layout-manager .dx-field-item.dx-last-row {
padding-top: 4px;
}
.dx-toast-info .dx-toast-icon {
display: none;
}
.buttons-group {
display: flex;
width: 100%;
justify-content: end;
}
.buttons-group .dx-item-content {
gap: 8px;
}
.buttons-group .dx-field-item:not(.dx-first-col),
.buttons-group .dx-field-item:not(.dx-last-col) {
padding: 0;
}
.buttons-group .dx-item {
flex: unset !important;
}
Use the following APIs to activate Smart Paste in our Form component:
- aiIntegration - accepts an AIIntegration object that contains AI Service settings.
- 'smartPaste' – adds a built-in Smart Paste button to the Form (see name for additional information). To use this capability in code, call the smartPaste(text) method. This sample leverages this method and implements a custom shortcut to activate Smart Paste.
Configure each Form item using aiOptions:
- disabled - prevents AI-generated text from being pasted into this item.
- instruction - specifies item instruction for the AI service.

Backend API
<template>
<div
class="instruction"
id="textarea-label"
>
Copy text from the editor below to the clipboard.
Edit the text to see how your changes affect Smart Paste result.
</div>
<div class="instruction">
Paste text from the clipboard to populate the form.
Press Ctrl+Shift+V (when the form is focused) or use the "Smart Paste" button under the form.
</div>
<div class="textarea-container">
<DxButton
text="Copy Text"
icon="copy"
stylingMode="contained"
type="default"
width="fit-content"
@click="onCopy()"
/>
<DxTextArea
id="textarea"
:input-attr="{ 'aria-labelledby': 'textarea-label' }"
v-model:value="text"
stylingMode="filled"
height="100%"
/>
</div>
<DxForm
id="form"
ref="formRef"
labelMode="outside"
labelLocation="top"
:showColonAfterLabel="false"
:minColWidth="220"
:aiIntegration="aiIntegration"
>
<DxGroupItem
:colCountByScreen="colCountByScreen"
caption="Billing Summary"
>
<DxItem
dataField="Amount Due"
editorType="dxTextBox"
:editorOptions="amountDueEditorOptions"
:aiOptions="amountDueAIOptions"
/>
<DxItem
dataField="Statement Date"
editorType="dxDateBox"
:editorOptions="statementDueEditorOptions"
:aiOptions="statementDueAIOptions"
/>
</DxGroupItem>
<DxGroupItem
:colCountByScreen="colCountByScreen"
caption="Billing Information"
>
<DxItem
dataField="First Name"
editorType="dxTextBox"
:editorOptions="textEditorOptions"
/>
<DxItem
dataField="Last Name"
editorType="dxTextBox"
:editorOptions="textEditorOptions"
/>
<DxItem
dataField="Phone Number"
editorType="dxTextBox"
:editorOptions="phoneEditorOptions"
:aiOptions="phoneAIOptions"
/>
<DxItem
dataField="Email"
editorType="dxTextBox"
:editorOptions="textEditorOptions"
:aiOptions="emailAIOptions"
:validationRules="emailValidationRules"
/>
</DxGroupItem>
<DxGroupItem
:colCountByScreen="colCountByScreen"
caption="Billing Address"
>
<DxItem
dataField="Street Address"
editorType="dxTextBox"
:editorOptions="textEditorOptions"
/>
<DxItem
dataField="City"
editorType="dxTextBox"
:editorOptions="textEditorOptions"
/>
<DxItem
dataField="State/Province/Region"
editorType="dxTextBox"
:editorOptions="textEditorOptions"
/>
<DxItem
dataField="ZIP"
editorType="dxNumberBox"
:editorOptions="zipEditorOptions"
:aiOptions="zipAIOptions"
/>
</DxGroupItem>
<DxGroupItem
cssClass="buttons-group"
:colCountByScreen="colCountByScreen"
>
<DxButtonItem
:buttonOptions="smartPasteButtonOptions"
name="smartPaste"
/>
<DxButtonItem
:buttonOptions="resetButtonOptions"
name="reset"
/>
</DxGroupItem>
</DxForm>
</template>
<script setup lang="ts">
import { onMounted, ref } from 'vue';
import { AzureOpenAI, type OpenAI } from 'openai';
import {
DxForm, DxItem, DxButtonItem, DxGroupItem,
} from 'devextreme-vue/form';
import type { ValidationRule } from 'devextreme-vue/common';
import type { RequestParams, Response } from 'devextreme-vue/common/ai-integration';
import { DxButton, type DxButtonTypes } from 'devextreme-vue/button';
import DxTextArea from 'devextreme-vue/text-area';
import { AIIntegration } from 'devextreme-vue/common/ai-integration';
import notify from 'devextreme/ui/notify';
import { AzureOpenAIConfig, defaultText } from './data.ts';
const text = ref(defaultText);
const formRef = ref();
type AIMessage = (
OpenAI.ChatCompletionUserMessageParam | OpenAI.ChatCompletionSystemMessageParam
) & {
content: string;
};
const aiService = new AzureOpenAI(AzureOpenAIConfig);
async function getAIResponse(messages: AIMessage[], signal: AbortSignal) {
const params = {
messages,
model: AzureOpenAIConfig.deployment,
max_completion_tokens: 1000,
temperature: 0.7,
};
const response = await aiService.chat.completions.create(params, { signal });
const result = response.choices[0].message?.content;
return result || '';
}
const aiIntegration = new AIIntegration({
sendRequest({ prompt }: RequestParams) {
const controller = new AbortController();
const signal = controller.signal;
const aiPrompt: AIMessage[] = [
{ role: 'system', content: prompt.system || '' },
{ role: 'user', content: prompt.user || '' },
];
const promise = getAIResponse(aiPrompt, signal);
promise.catch(() => {
showNotification('Something went wrong. Please try again.', '#form', true);
});
const result: Response = {
promise,
abort: () => {
controller.abort();
},
};
return result;
},
});
const stylingMode = 'filled';
const amountDueEditorOptions = { placeholder: '$0.00', stylingMode };
const amountDueAIOptions = { instruction: 'Format as the following: $0.00' };
const statementDueEditorOptions = { placeholder: 'MM/DD/YYYY', stylingMode };
const statementDueAIOptions = { instruction: 'Format as the following: MM/DD/YYYY' };
const textEditorOptions = { stylingMode };
const phoneEditorOptions = { placeholder: '(000) 000-0000', stylingMode };
const phoneAIOptions = { instruction: 'Format as the following: (000) 000-0000' };
const emailValidationRules: ValidationRule[] = [{ type: 'email' }];
const emailAIOptions = { instruction: 'Do not fill this field if the text contains an invalid email address. A valid email is in the following format: email@example.com' };
const zipEditorOptions = { stylingMode, mode: 'text' };
const zipAIOptions = { instruction: 'If the text does not contain a ZIP, determine the ZIP code from the provided address.' };
const resetButtonOptions: DxButtonTypes.Properties = {
stylingMode: 'outlined',
type: 'normal',
};
const smartPasteButtonOptions: DxButtonTypes.Properties = {
stylingMode: 'contained',
type: 'default',
};
const colCountByScreen = {
xs: 2,
sm: 2,
md: 2,
lg: 2,
};
const showNotification = (message: string, of: string, isError?: boolean, offset?: string) => {
notify({
message,
position: {
my: 'bottom center',
at: 'bottom center',
of,
offset: offset ?? '0 -50',
},
width: 'fit-content',
maxWidth: 'fit-content',
minWidth: 'fit-content',
}, isError ? 'error' : 'info', 1500);
};
const onCopy = () => {
navigator.clipboard.writeText(text.value);
showNotification('Text copied to clipboard', '#textarea', false, '0 -20');
};
onMounted(() => {
formRef.value.instance.registerKeyHandler('V', (event: KeyboardEvent) => {
if (event.ctrlKey && event.shiftKey) {
navigator.clipboard.readText()
.then((clipboardText) => {
if (clipboardText) {
formRef.value.instance.smartPaste(clipboardText);
} else {
showNotification('Clipboard is empty. Copy text before pasting', '#form');
}
})
.catch(() => {
showNotification('Could not access the clipboard', '#form');
});
}
});
});
</script>
<style scoped>
#app {
display: grid;
grid-template-columns: 1fr 2fr;
grid-template-rows: auto auto;
gap: 24px 40px;
min-width: 720px;
max-width: 900px;
margin: auto;
}
.instruction {
color: var(--dx-texteditor-color-label);
}
.textarea-container {
display: flex;
flex-direction: column;
gap: 16px;
}
.dx-layout-manager .dx-field-item.dx-last-row {
padding-top: 4px;
}
.dx-toast-info .dx-toast-icon {
display: none;
}
.buttons-group {
display: flex;
width: 100%;
justify-content: end;
}
.buttons-group .dx-item-content {
gap: 8px;
}
.buttons-group .dx-field-item:not(.dx-first-col),
.buttons-group .dx-field-item:not(.dx-last-col) {
padding: 0;
}
.buttons-group .dx-item {
flex: unset !important;
}
</style>
<template>
<div id="template-content">
<i
id="helpedInfo"
class="dx-icon dx-icon-info"
/>
Additional
<br>
{{ data.text }}
<DxTooltip
target="#helpedInfo"
show-event="mouseenter"
hide-event="mouseleave"
>
<template #content>
<div id="tooltip-content">This field must not exceed 200 characters</div>
</template>
</DxTooltip>
</div>
</template>
<script setup lang="ts">
import { DxTooltip } from 'devextreme-vue/tooltip';
withDefaults(defineProps<{
data?: Record<string, any>
}>(), {
data: () => ({} as Record<string, any>),
});
</script>
<style scoped>
#helpedInfo {
color: #42a5f5;
}
#tooltip-content {
font-size: 14px;
font-weight: bold;
}
#template-content {
display: inline-flex;
}
</style>
<template>
<div>
<i :class="`dx-icon dx-icon-${icon}`"/>{{ data.text }}
</div>
</template>
<script setup lang="ts">
withDefaults(defineProps<{
data?: Record<string, any>
icon?: string
}>(), {
data: () => ({} as Record<string, any>),
icon: 'info',
});
</script>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.40/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.26/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'openai': 'externals:openai.bundle.js',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"openai": {
"version": "4.73.1"
},
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
export const AzureOpenAIConfig = {
dangerouslyAllowBrowser: true,
deployment: 'demo-mini',
apiVersion: '2024-02-01',
endpoint: 'https://public-api.devexpress.com/demo-openai',
apiKey: 'DEMO',
};
export const defaultText = `Payment: Amount - $123.00
Statement Date: 10/15/2024
Name: John Smith
Contact: (123) 456-7890
Email: john@myemail.com
Address:
- 123 Elm St Apt 4B
- New York, NY 10001
`;
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
Use the following APIs to activate Smart Paste in our Form component:
- aiIntegration - accepts an AIIntegration object that contains AI Service settings.
- 'smartPaste' – adds a built-in Smart Paste button to the Form (see name for additional information). To use this capability in code, call the smartPaste(text) method. This sample leverages this method and implements a custom shortcut to activate Smart Paste.
Configure each Form item using aiOptions:
- disabled - prevents AI-generated text from being pasted into this item.
- instruction - specifies item instruction for the AI service.

Backend API
<div id="form-container">
<div class="instruction" id="textarea-label"
>Copy text from the editor below to the clipboard. Edit the text to see how
your changes affect Smart Paste result.</div
>
<div class="instruction"
>Paste text from the clipboard to populate the form. Press Ctrl+Shift+V
(when the form is focused) or use the "Smart Paste" button under the
form.</div
>
<div class="textarea-container">
<dx-button
id="copy"
text="Copy Text"
icon="copy"
stylingMode="contained"
type="default"
width="fit-content"
(onClick)="onCopy()"
></dx-button>
<dx-text-area
id="textarea"
[elementAttr]="{ 'aria-labelledby': 'textarea-label' }"
[(value)]="text"
stylingMode="filled"
height="100%"
></dx-text-area>
</div>
<dx-form
id="form"
labelMode="outside"
labelLocation="top"
[showColonAfterLabel]="false"
[minColWidth]="220"
[aiIntegration]="aiIntegration"
stylingMode="filled"
>
<dxi-form-item
itemType="group"
[colCountByScreen]="colCountByScreen"
caption="Billing Summary"
>
<dxi-form-item
dataField="Amount Due"
editorType="dxTextBox"
[editorOptions]="amountDueEditorOptions"
[aiOptions]="amountDueAIOptions"
></dxi-form-item>
<dxi-form-item
dataField="Statement Date"
editorType="dxDateBox"
[editorOptions]="statementDueEditorOptions"
[aiOptions]="statementDueAIOptions"
></dxi-form-item>
</dxi-form-item>
<dxi-form-item
itemType="group"
[colCountByScreen]="colCountByScreen"
caption="Billing Information"
>
<dxi-form-item
dataField="First Name"
editorType="dxTextBox"
[editorOptions]="textEditorOptions"
></dxi-form-item>
<dxi-form-item
dataField="Last Name"
editorType="dxTextBox"
[editorOptions]="textEditorOptions"
></dxi-form-item>
<dxi-form-item
dataField="Phone Number"
editorType="dxTextBox"
[editorOptions]="phoneEditorOptions"
[aiOptions]="phoneAIOptions"
>
</dxi-form-item>
<dxi-form-item
dataField="Email"
editorType="dxTextBox"
[editorOptions]="textEditorOptions"
[aiOptions]="emailAIOptions"
>
<dxi-form-validation-rule type="email"></dxi-form-validation-rule>
</dxi-form-item>
</dxi-form-item>
<dxi-form-item
itemType="group"
[colCountByScreen]="colCountByScreen"
caption="Billing Address"
>
<dxi-form-item
dataField="Street Address"
editorType="dxTextBox"
[editorOptions]="textEditorOptions"
></dxi-form-item>
<dxi-form-item
dataField="City"
editorType="dxTextBox"
[editorOptions]="textEditorOptions"
></dxi-form-item>
<dxi-form-item
dataField="State/Province/Region"
editorType="dxTextBox"
[editorOptions]="textEditorOptions"
></dxi-form-item>
<dxi-form-item
dataField="ZIP"
editorType="dxNumberBox"
[editorOptions]="zipEditorOptions"
[aiOptions]="zipAIOptions"
></dxi-form-item>
</dxi-form-item>
<dxi-form-item
itemType="group"
cssClass="buttons-group"
[colCountByScreen]="colCountByScreen"
>
<dxi-form-item
itemType="button"
name="smartPaste"
[buttonOptions]="smartPasteButtonOptions"
></dxi-form-item>
<dxi-form-item
itemType="button"
name="reset"
[buttonOptions]="resetButtonOptions"
></dxi-form-item>
</dxi-form-item>
</dx-form>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, ViewChild, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { AzureOpenAI, type OpenAI } from 'openai';
import { DxTextAreaModule } from 'devextreme-angular';
import {
AIIntegration,
RequestParams,
Response,
} from 'devextreme-angular/common/ai-integration';
import { DxButtonModule, type DxButtonTypes } from 'devextreme-angular/ui/button';
import { DxFormModule, DxFormComponent } from 'devextreme-angular/ui/form';
import notify from 'devextreme/ui/notify';
import { Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
const stylingMode = 'filled';
type AIMessage = (OpenAI.ChatCompletionUserMessageParam | OpenAI.ChatCompletionSystemMessageParam) & {
content: string;
};
const showNotification = (message: string, of: string, isError?: boolean, offset?: string) => {
notify({
message,
position: {
my: 'bottom center',
at: 'bottom center',
of,
offset: offset ?? '0 -50',
},
width: 'fit-content',
maxWidth: 'fit-content',
minWidth: 'fit-content',
}, isError ? 'error' : 'info', 1500);
};
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxButtonModule,
DxFormModule,
DxTextAreaModule,
],
})
export class AppComponent {
@ViewChild(DxFormComponent, { static: false }) form: DxFormComponent;
colCountByScreen = {
xs: 2,
sm: 2,
md: 2,
lg: 2,
};
amountDueEditorOptions = { placeholder: '$0.00', stylingMode };
amountDueAIOptions = { instruction: 'Format as the following: $0.00' };
statementDueEditorOptions = { placeholder: 'MM/DD/YYYY', stylingMode };
statementDueAIOptions = { instruction: 'Format as the following: MM/DD/YYYY' };
textEditorOptions = { stylingMode };
phoneEditorOptions = { placeholder: '(000) 000-0000', stylingMode };
phoneAIOptions = { instruction: 'Format as the following: (000) 000-0000' };
emailAIOptions = { instruction: 'Do not fill this field if the text contains an invalid email address. A valid email is in the following format: email@example.com' };
zipEditorOptions = { stylingMode, mode: 'text' };
zipAIOptions = { instruction: 'If the text does not contain a ZIP, determine the ZIP code from the provided address.' };
resetButtonOptions: DxButtonTypes.Properties = {
stylingMode: 'outlined',
type: 'normal',
};
smartPasteButtonOptions: DxButtonTypes.Properties = {
stylingMode: 'contained',
type: 'default',
};
azureOpenAIConfig: any;
aiService: AzureOpenAI;
aiIntegration: AIIntegration;
valueContent: string;
text: string;
constructor(service: Service) {
this.azureOpenAIConfig = service.getAzureOpenAIConfig();
this.aiService = new AzureOpenAI(this.azureOpenAIConfig);
this.aiIntegration = new AIIntegration({
sendRequest: this.sendRequest.bind(this),
});
this.text = service.getDefaultText();
}
ngAfterViewInit() {
const form = this.form.instance;
form.registerKeyHandler('V', (event: KeyboardEvent) => {
if (event.ctrlKey && event.shiftKey) {
navigator.clipboard.readText()
.then((clipboardText) => {
if (clipboardText) {
form.smartPaste(clipboardText);
} else {
showNotification('Clipboard is empty. Copy text before pasting', '#form');
}
})
.catch(() => {
showNotification('Could not access the clipboard', '#form');
});
}
});
}
sendRequest({ prompt }: RequestParams): Response {
const controller = new AbortController();
const signal = controller.signal;
const aiPrompt: AIMessage[] = [
{ role: 'system', content: prompt.system },
{ role: 'user', content: prompt.user },
];
const promise = this.getAIResponse(aiPrompt, signal);
promise.catch(() => {
showNotification('Something went wrong. Please try again.', '#form', true);
});
const result: Response = {
promise,
abort: () => {
controller.abort();
},
};
return result;
}
async getAIResponse(messages: AIMessage[], signal: AbortSignal) {
const params = {
messages,
model: this.azureOpenAIConfig.deployment,
max_completion_tokens: 1000,
temperature: 0.7,
};
const response = await this.aiService.chat.completions.create(params, { signal });
const result = response.choices[0].message?.content;
return result;
}
onCopy() {
navigator.clipboard.writeText(this.text);
showNotification('Text copied to clipboard', '#textarea', false, '0 -20');
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
#form-container {
display: grid;
grid-template-columns: 1fr 2fr;
grid-template-rows: auto auto;
gap: 24px 40px;
min-width: 720px;
max-width: 900px;
margin: auto;
}
.instruction {
color: var(--dx-texteditor-color-label);
}
.textarea-container {
display: flex;
flex-direction: column;
gap: 16px;
}
::ng-deep .dx-layout-manager .dx-field-item.dx-last-row {
padding-top: 4px;
}
::ng-deep .dx-toast-info .dx-toast-icon {
display: none;
}
::ng-deep .buttons-group {
display: flex;
width: 100%;
justify-content: end;
}
::ng-deep .buttons-group .dx-item-content {
gap: 8px;
}
::ng-deep .buttons-group .dx-field-item:not(.dx-first-col),
::ng-deep .buttons-group .dx-field-item:not(.dx-last-col) {
padding: 0;
}
::ng-deep .buttons-group .dx-item {
flex: unset !important;
}
import { Injectable } from '@angular/core';
const AzureOpenAIConfig = {
dangerouslyAllowBrowser: true,
deployment: 'demo-mini',
apiVersion: '2024-02-01',
endpoint: 'https://public-api.devexpress.com/demo-openai',
apiKey: 'DEMO',
};
const defaultText = `Payment: Amount - $123.00
Statement Date: 10/15/2024
Name: John Smith
Contact: (123) 456-7890
Email: john@myemail.com
Address:
- 123 Elm St Apt 4B
- New York, NY 10001
`;
@Injectable({
providedIn: 'root',
})
export class Service {
getDefaultText() {
return defaultText;
}
getAzureOpenAIConfig() {
return AzureOpenAIConfig;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'openai': 'externals:openai.bundle.js',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"openai": {
"version": "4.73.1"
},
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.1.0"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
Use the following APIs to activate Smart Paste in our Form component:
- aiIntegration - accepts an AIIntegration object that contains AI Service settings.
- 'smartPaste' – adds a built-in Smart Paste button to the Form (see name for additional information). To use this capability in code, call the smartPaste(text) method. This sample leverages this method and implements a custom shortcut to activate Smart Paste.
Configure each Form item using aiOptions:
- disabled - prevents AI-generated text from being pasted into this item.
- instruction - specifies item instruction for the AI service.